/*{{{  includes*/
/*{{{  For printf's*/
#include <stdio.h>
/*}}}  */
/*{{{  For Vectram Library*/
#include "decc14.h"
#include "memc14.h"
/*}}}  */
/*}}}  */
/*{{{  declarations*/
int error_code, stride_a, stride_b, stride_c, flag;
float *a  = (float*)0x60010000;
float *b =  (float*)0x60016000;
float *c =  (float*)0x6001c000;
int   *d =    (int*)0x60022000;
int   *e =    (int*)0x60028000;
/*}}}  */
/*{{{  print3realdata*/
void print3realdata ( float *array1,
                      int    stride1,
                      float *array2,
                      int    stride2,
                      float *array3,
                      int    stride3,
                      int    notoprint)
{
  int i, ii, jj, kk;
  ii =0;
  jj =0;
  kk =0;
  for (i=0; i< notoprint; i++){
      printf("element %d    Input1 = %4.6f   input2 = %4.6f     output = %4.6f\n",
             i, array1[ii], array2[jj], array3[kk]);

     ii =ii + (stride1);
     jj =jj + (stride2);
     kk =kk + (stride3);

  }
}
/*}}}  */
/*{{{  main*/
int main(void)
{
    /*{{{  Preamble*/
    int i, n;
    flag = 0;
    n = 10;
    stride_a = 1;
    stride_b = 1;
    stride_c = 1;
    /*}}}  */
    /*{{{  Start up message*/
    printf("IMS F000B Vectram C example program \n");
    printf("Multiplies 2 vectors \n");
    /*}}}  */
    /*{{{  Initialise Coprocessor*/
    error_code = VT_INIT( COPROCESSOR_MEM_BASE,
                          LIB_WORKSPACE_BASE,
                          LIB_WORKSPACE_BASE,
                          COPROCESSOR_MEM_TOP);
    /*}}}  */
    if (error_code==0)
    {
      /*{{{  Initialise data*/
      for(i = 0; i < 20; i++) {
        a[i] = (float) 10.0;
        b[i] = (float) 20.0;
      }
      /*}}}  */
      /*{{{  Multiply Vectors*/
      
      error_code = VT_MULT_F32R ( a,
                                  stride_a,
                                  b,
                                  stride_b,
                                  c,
                                  stride_c,
                                  n,
                                  flag);
      print3realdata ( a,
                       stride_a,
                       b,
                       stride_b,
                       c,
                       stride_c,
                       10);
      
      /*}}}  */
    }
    printf ("Error was %d", error_code);
}
/*}}}  */
